Code

Merge branch 'rj/test-fixes' into next
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset GIT_EDITOR
47 unset AUTHOR_DATE
48 unset AUTHOR_EMAIL
49 unset AUTHOR_NAME
50 unset COMMIT_AUTHOR_EMAIL
51 unset COMMIT_AUTHOR_NAME
52 unset EMAIL
53 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54 unset GIT_AUTHOR_DATE
55 GIT_AUTHOR_EMAIL=author@example.com
56 GIT_AUTHOR_NAME='A U Thor'
57 unset GIT_COMMITTER_DATE
58 GIT_COMMITTER_EMAIL=committer@example.com
59 GIT_COMMITTER_NAME='C O Mitter'
60 unset GIT_DIFF_OPTS
61 unset GIT_DIR
62 unset GIT_WORK_TREE
63 unset GIT_EXTERNAL_DIFF
64 unset GIT_INDEX_FILE
65 unset GIT_OBJECT_DIRECTORY
66 unset GIT_CEILING_DIRECTORIES
67 unset SHA1_FILE_DIRECTORIES
68 unset SHA1_FILE_DIRECTORY
69 unset GIT_NOTES_REF
70 unset GIT_NOTES_DISPLAY_REF
71 unset GIT_NOTES_REWRITE_REF
72 unset GIT_NOTES_REWRITE_MODE
73 GIT_MERGE_VERBOSITY=5
74 export GIT_MERGE_VERBOSITY
75 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
77 export EDITOR
79 # Protect ourselves from common misconfiguration to export
80 # CDPATH into the environment
81 unset CDPATH
83 unset GREP_OPTIONS
85 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
86         1|2|true)
87                 echo "* warning: Some tests will not work if GIT_TRACE" \
88                         "is set as to trace on STDERR ! *"
89                 echo "* warning: Please set GIT_TRACE to something" \
90                         "other than 1, 2 or true ! *"
91                 ;;
92 esac
94 # Convenience
95 #
96 # A regexp to match 5 and 40 hexdigits
97 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
98 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
100 # Each test should start with something like this, after copyright notices:
102 # test_description='Description of this test...
103 # This test checks if command xyzzy does the right thing...
104 # '
105 # . ./test-lib.sh
106 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
107                 TERM=$ORIGINAL_TERM &&
108                 export TERM &&
109                 [ -t 1 ] &&
110                 tput bold >/dev/null 2>&1 &&
111                 tput setaf 1 >/dev/null 2>&1 &&
112                 tput sgr0 >/dev/null 2>&1
113         ) &&
114         color=t
116 while test "$#" -ne 0
117 do
118         case "$1" in
119         -d|--d|--de|--deb|--debu|--debug)
120                 debug=t; shift ;;
121         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122                 immediate=t; shift ;;
123         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
124                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
125         -h|--h|--he|--hel|--help)
126                 help=t; shift ;;
127         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128                 verbose=t; shift ;;
129         -q|--q|--qu|--qui|--quie|--quiet)
130                 # Ignore --quiet under a TAP::Harness. Saying how many tests
131                 # passed without the ok/not ok details is always an error.
132                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
133         --with-dashes)
134                 with_dashes=t; shift ;;
135         --no-color)
136                 color=; shift ;;
137         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
138                 valgrind=t; verbose=t; shift ;;
139         --tee)
140                 shift ;; # was handled already
141         --root=*)
142                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
143                 shift ;;
144         *)
145                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
146         esac
147 done
149 if test -n "$color"; then
150         say_color () {
151                 (
152                 TERM=$ORIGINAL_TERM
153                 export TERM
154                 case "$1" in
155                         error) tput bold; tput setaf 1;; # bold red
156                         skip)  tput bold; tput setaf 2;; # bold green
157                         pass)  tput setaf 2;;            # green
158                         info)  tput setaf 3;;            # brown
159                         *) test -n "$quiet" && return;;
160                 esac
161                 shift
162                 printf "%s" "$*"
163                 tput sgr0
164                 echo
165                 )
166         }
167 else
168         say_color() {
169                 test -z "$1" && test -n "$quiet" && return
170                 shift
171                 echo "$*"
172         }
173 fi
175 error () {
176         say_color error "error: $*"
177         GIT_EXIT_OK=t
178         exit 1
181 say () {
182         say_color info "$*"
185 test "${test_description}" != "" ||
186 error "Test script did not set test_description."
188 if test "$help" = "t"
189 then
190         echo "$test_description"
191         exit 0
192 fi
194 exec 5>&1
195 if test "$verbose" = "t"
196 then
197         exec 4>&2 3>&1
198 else
199         exec 4>/dev/null 3>/dev/null
200 fi
202 test_failure=0
203 test_count=0
204 test_fixed=0
205 test_broken=0
206 test_success=0
208 test_external_has_tap=0
210 die () {
211         code=$?
212         if test -n "$GIT_EXIT_OK"
213         then
214                 exit $code
215         else
216                 echo >&5 "FATAL: Unexpected exit with code $code"
217                 exit 1
218         fi
221 GIT_EXIT_OK=
222 trap 'die' EXIT
224 # The semantics of the editor variables are that of invoking
225 # sh -c "$EDITOR \"$@\"" files ...
227 # If our trash directory contains shell metacharacters, they will be
228 # interpreted if we just set $EDITOR directly, so do a little dance with
229 # environment variables to work around this.
231 # In particular, quoting isn't enough, as the path may contain the same quote
232 # that we're using.
233 test_set_editor () {
234         FAKE_EDITOR="$1"
235         export FAKE_EDITOR
236         EDITOR='"$FAKE_EDITOR"'
237         export EDITOR
240 test_decode_color () {
241         awk '
242                 function name(n) {
243                         if (n == 0) return "RESET";
244                         if (n == 1) return "BOLD";
245                         if (n == 30) return "BLACK";
246                         if (n == 31) return "RED";
247                         if (n == 32) return "GREEN";
248                         if (n == 33) return "YELLOW";
249                         if (n == 34) return "BLUE";
250                         if (n == 35) return "MAGENTA";
251                         if (n == 36) return "CYAN";
252                         if (n == 37) return "WHITE";
253                         if (n == 40) return "BLACK";
254                         if (n == 41) return "BRED";
255                         if (n == 42) return "BGREEN";
256                         if (n == 43) return "BYELLOW";
257                         if (n == 44) return "BBLUE";
258                         if (n == 45) return "BMAGENTA";
259                         if (n == 46) return "BCYAN";
260                         if (n == 47) return "BWHITE";
261                 }
262                 {
263                         while (match($0, /\033\[[0-9;]*m/) != 0) {
264                                 printf "%s<", substr($0, 1, RSTART-1);
265                                 codes = substr($0, RSTART+2, RLENGTH-3);
266                                 if (length(codes) == 0)
267                                         printf "%s", name(0)
268                                 else {
269                                         n = split(codes, ary, ";");
270                                         sep = "";
271                                         for (i = 1; i <= n; i++) {
272                                                 printf "%s%s", sep, name(ary[i]);
273                                                 sep = ";"
274                                         }
275                                 }
276                                 printf ">";
277                                 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
278                         }
279                         print
280                 }
281         '
284 nul_to_q () {
285         perl -pe 'y/\000/Q/'
288 q_to_nul () {
289         perl -pe 'y/Q/\000/'
292 q_to_cr () {
293         tr Q '\015'
296 q_to_tab () {
297         tr Q '\011'
300 append_cr () {
301         sed -e 's/$/Q/' | tr Q '\015'
304 remove_cr () {
305         tr '\015' Q | sed -e 's/Q$//'
308 # In some bourne shell implementations, the "unset" builtin returns
309 # nonzero status when a variable to be unset was not set in the first
310 # place.
312 # Use sane_unset when that should not be considered an error.
314 sane_unset () {
315         unset "$@"
316         return 0
319 test_tick () {
320         if test -z "${test_tick+set}"
321         then
322                 test_tick=1112911993
323         else
324                 test_tick=$(($test_tick + 60))
325         fi
326         GIT_COMMITTER_DATE="$test_tick -0700"
327         GIT_AUTHOR_DATE="$test_tick -0700"
328         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
331 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
333 # This will commit a file with the given contents and the given commit
334 # message.  It will also add a tag with <message> as name.
336 # Both <file> and <contents> default to <message>.
338 test_commit () {
339         file=${2:-"$1.t"}
340         echo "${3-$1}" > "$file" &&
341         git add "$file" &&
342         test_tick &&
343         git commit -m "$1" &&
344         git tag "$1"
347 # Call test_merge with the arguments "<message> <commit>", where <commit>
348 # can be a tag pointing to the commit-to-merge.
350 test_merge () {
351         test_tick &&
352         git merge -m "$1" "$2" &&
353         git tag "$1"
356 # This function helps systems where core.filemode=false is set.
357 # Use it instead of plain 'chmod +x' to set or unset the executable bit
358 # of a file in the working directory and add it to the index.
360 test_chmod () {
361         chmod "$@" &&
362         git update-index --add "--chmod=$@"
365 # Use test_set_prereq to tell that a particular prerequisite is available.
366 # The prerequisite can later be checked for in two ways:
368 # - Explicitly using test_have_prereq.
370 # - Implicitly by specifying the prerequisite tag in the calls to
371 #   test_expect_{success,failure,code}.
373 # The single parameter is the prerequisite tag (a simple word, in all
374 # capital letters by convention).
376 test_set_prereq () {
377         satisfied="$satisfied$1 "
379 satisfied=" "
381 test_have_prereq () {
382         # prerequisites can be concatenated with ','
383         save_IFS=$IFS
384         IFS=,
385         set -- $*
386         IFS=$save_IFS
388         total_prereq=0
389         ok_prereq=0
390         missing_prereq=
392         for prerequisite
393         do
394                 total_prereq=$(($total_prereq + 1))
395                 case $satisfied in
396                 *" $prerequisite "*)
397                         ok_prereq=$(($ok_prereq + 1))
398                         ;;
399                 *)
400                         # Keep a list of missing prerequisites
401                         if test -z "$missing_prereq"
402                         then
403                                 missing_prereq=$prerequisite
404                         else
405                                 missing_prereq="$prerequisite,$missing_prereq"
406                         fi
407                 esac
408         done
410         test $total_prereq = $ok_prereq
413 test_declared_prereq () {
414         case ",$test_prereq," in
415         *,$1,*)
416                 return 0
417                 ;;
418         esac
419         return 1
422 # You are not expected to call test_ok_ and test_failure_ directly, use
423 # the text_expect_* functions instead.
425 test_ok_ () {
426         test_success=$(($test_success + 1))
427         say_color "" "ok $test_count - $@"
430 test_failure_ () {
431         test_failure=$(($test_failure + 1))
432         say_color error "not ok - $test_count $1"
433         shift
434         echo "$@" | sed -e 's/^/#       /'
435         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
438 test_known_broken_ok_ () {
439         test_fixed=$(($test_fixed+1))
440         say_color "" "ok $test_count - $@ # TODO known breakage"
443 test_known_broken_failure_ () {
444         test_broken=$(($test_broken+1))
445         say_color skip "not ok $test_count - $@ # TODO known breakage"
448 test_debug () {
449         test "$debug" = "" || eval "$1"
452 test_run_ () {
453         test_cleanup=:
454         eval >&3 2>&4 "$1"
455         eval_ret=$?
456         eval >&3 2>&4 "$test_cleanup"
457         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
458                 echo ""
459         fi
460         return 0
463 test_skip () {
464         test_count=$(($test_count+1))
465         to_skip=
466         for skp in $GIT_SKIP_TESTS
467         do
468                 case $this_test.$test_count in
469                 $skp)
470                         to_skip=t
471                         break
472                 esac
473         done
474         if test -z "$to_skip" && test -n "$test_prereq" &&
475            ! test_have_prereq "$test_prereq"
476         then
477                 to_skip=t
478         fi
479         case "$to_skip" in
480         t)
481                 of_prereq=
482                 if test "$missing_prereq" != "$test_prereq"
483                 then
484                         of_prereq=" of $test_prereq"
485                 fi
487                 say_color skip >&3 "skipping test: $@"
488                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
489                 : true
490                 ;;
491         *)
492                 false
493                 ;;
494         esac
497 test_expect_failure () {
498         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
499         test "$#" = 2 ||
500         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
501         export test_prereq
502         if ! test_skip "$@"
503         then
504                 say >&3 "checking known breakage: $2"
505                 test_run_ "$2"
506                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
507                 then
508                         test_known_broken_ok_ "$1"
509                 else
510                         test_known_broken_failure_ "$1"
511                 fi
512         fi
513         echo >&3 ""
516 test_expect_success () {
517         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
518         test "$#" = 2 ||
519         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
520         export test_prereq
521         if ! test_skip "$@"
522         then
523                 say >&3 "expecting success: $2"
524                 test_run_ "$2"
525                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
526                 then
527                         test_ok_ "$1"
528                 else
529                         test_failure_ "$@"
530                 fi
531         fi
532         echo >&3 ""
535 # test_external runs external test scripts that provide continuous
536 # test output about their progress, and succeeds/fails on
537 # zero/non-zero exit code.  It outputs the test output on stdout even
538 # in non-verbose mode, and announces the external script with "# run
539 # <n>: ..." before running it.  When providing relative paths, keep in
540 # mind that all scripts run in "trash directory".
541 # Usage: test_external description command arguments...
542 # Example: test_external 'Perl API' perl ../path/to/test.pl
543 test_external () {
544         test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
545         test "$#" = 3 ||
546         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
547         descr="$1"
548         shift
549         export test_prereq
550         if ! test_skip "$descr" "$@"
551         then
552                 # Announce the script to reduce confusion about the
553                 # test output that follows.
554                 say_color "" "# run $test_count: $descr ($*)"
555                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
556                 # to be able to use them in script
557                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
558                 # Run command; redirect its stderr to &4 as in
559                 # test_run_, but keep its stdout on our stdout even in
560                 # non-verbose mode.
561                 "$@" 2>&4
562                 if [ "$?" = 0 ]
563                 then
564                         if test $test_external_has_tap -eq 0; then
565                                 test_ok_ "$descr"
566                         else
567                                 say_color "" "# test_external test $descr was ok"
568                                 test_success=$(($test_success + 1))
569                         fi
570                 else
571                         if test $test_external_has_tap -eq 0; then
572                                 test_failure_ "$descr" "$@"
573                         else
574                                 say_color error "# test_external test $descr failed: $@"
575                                 test_failure=$(($test_failure + 1))
576                         fi
577                 fi
578         fi
581 # Like test_external, but in addition tests that the command generated
582 # no output on stderr.
583 test_external_without_stderr () {
584         # The temporary file has no (and must have no) security
585         # implications.
586         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
587         stderr="$tmp/git-external-stderr.$$.tmp"
588         test_external "$@" 4> "$stderr"
589         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
590         descr="no stderr: $1"
591         shift
592         say >&3 "# expecting no stderr from previous command"
593         if [ ! -s "$stderr" ]; then
594                 rm "$stderr"
596                 if test $test_external_has_tap -eq 0; then
597                         test_ok_ "$descr"
598                 else
599                         say_color "" "# test_external_without_stderr test $descr was ok"
600                         test_success=$(($test_success + 1))
601                 fi
602         else
603                 if [ "$verbose" = t ]; then
604                         output=`echo; echo "# Stderr is:"; cat "$stderr"`
605                 else
606                         output=
607                 fi
608                 # rm first in case test_failure exits.
609                 rm "$stderr"
610                 if test $test_external_has_tap -eq 0; then
611                         test_failure_ "$descr" "$@" "$output"
612                 else
613                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
614                         test_failure=$(($test_failure + 1))
615                 fi
616         fi
619 # debugging-friendly alternatives to "test [-f|-d|-e]"
620 # The commands test the existence or non-existence of $1. $2 can be
621 # given to provide a more precise diagnosis.
622 test_path_is_file () {
623         if ! [ -f "$1" ]
624         then
625                 echo "File $1 doesn't exist. $*"
626                 false
627         fi
630 test_path_is_dir () {
631         if ! [ -d "$1" ]
632         then
633                 echo "Directory $1 doesn't exist. $*"
634                 false
635         fi
638 test_path_is_missing () {
639         if [ -e "$1" ]
640         then
641                 echo "Path exists:"
642                 ls -ld "$1"
643                 if [ $# -ge 1 ]; then
644                         echo "$*"
645                 fi
646                 false
647         fi
650 # test_line_count checks that a file has the number of lines it
651 # ought to. For example:
653 #       test_expect_success 'produce exactly one line of output' '
654 #               do something >output &&
655 #               test_line_count = 1 output
656 #       '
658 # is like "test $(wc -l <output) = 1" except that it passes the
659 # output through when the number of lines is wrong.
661 test_line_count () {
662         if test $# != 3
663         then
664                 error "bug in the test script: not 3 parameters to test_line_count"
665         elif ! test $(wc -l <"$3") "$1" "$2"
666         then
667                 echo "test_line_count: line count for $3 !$1 $2"
668                 cat "$3"
669                 return 1
670         fi
673 # This is not among top-level (test_expect_success | test_expect_failure)
674 # but is a prefix that can be used in the test script, like:
676 #       test_expect_success 'complain and die' '
677 #           do something &&
678 #           do something else &&
679 #           test_must_fail git checkout ../outerspace
680 #       '
682 # Writing this as "! git checkout ../outerspace" is wrong, because
683 # the failure could be due to a segv.  We want a controlled failure.
685 test_must_fail () {
686         "$@"
687         exit_code=$?
688         if test $exit_code = 0; then
689                 echo >&2 "test_must_fail: command succeeded: $*"
690                 return 1
691         elif test $exit_code -gt 129 -a $exit_code -le 192; then
692                 echo >&2 "test_must_fail: died by signal: $*"
693                 return 1
694         elif test $exit_code = 127; then
695                 echo >&2 "test_must_fail: command not found: $*"
696                 return 1
697         fi
698         return 0
701 # Similar to test_must_fail, but tolerates success, too.  This is
702 # meant to be used in contexts like:
704 #       test_expect_success 'some command works without configuration' '
705 #               test_might_fail git config --unset all.configuration &&
706 #               do something
707 #       '
709 # Writing "git config --unset all.configuration || :" would be wrong,
710 # because we want to notice if it fails due to segv.
712 test_might_fail () {
713         "$@"
714         exit_code=$?
715         if test $exit_code -gt 129 -a $exit_code -le 192; then
716                 echo >&2 "test_might_fail: died by signal: $*"
717                 return 1
718         elif test $exit_code = 127; then
719                 echo >&2 "test_might_fail: command not found: $*"
720                 return 1
721         fi
722         return 0
725 # Similar to test_must_fail and test_might_fail, but check that a
726 # given command exited with a given exit code. Meant to be used as:
728 #       test_expect_success 'Merge with d/f conflicts' '
729 #               test_expect_code 1 git merge "merge msg" B master
730 #       '
732 test_expect_code () {
733         want_code=$1
734         shift
735         "$@"
736         exit_code=$?
737         if test $exit_code = $want_code
738         then
739                 echo >&2 "test_expect_code: command exited with $exit_code: $*"
740                 return 0
741         else
742                 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
743                 return 1
744         fi
747 # test_cmp is a helper function to compare actual and expected output.
748 # You can use it like:
750 #       test_expect_success 'foo works' '
751 #               echo expected >expected &&
752 #               foo >actual &&
753 #               test_cmp expected actual
754 #       '
756 # This could be written as either "cmp" or "diff -u", but:
757 # - cmp's output is not nearly as easy to read as diff -u
758 # - not all diff versions understand "-u"
760 test_cmp() {
761         $GIT_TEST_CMP "$@"
764 # This function can be used to schedule some commands to be run
765 # unconditionally at the end of the test to restore sanity:
767 #       test_expect_success 'test core.capslock' '
768 #               git config core.capslock true &&
769 #               test_when_finished "git config --unset core.capslock" &&
770 #               hello world
771 #       '
773 # That would be roughly equivalent to
775 #       test_expect_success 'test core.capslock' '
776 #               git config core.capslock true &&
777 #               hello world
778 #               git config --unset core.capslock
779 #       '
781 # except that the greeting and config --unset must both succeed for
782 # the test to pass.
784 test_when_finished () {
785         test_cleanup="{ $*
786                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
789 # Most tests can use the created repository, but some may need to create more.
790 # Usage: test_create_repo <directory>
791 test_create_repo () {
792         test "$#" = 1 ||
793         error "bug in the test script: not 1 parameter to test-create-repo"
794         repo="$1"
795         mkdir -p "$repo"
796         (
797                 cd "$repo" || error "Cannot setup test environment"
798                 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
799                 error "cannot run git init -- have you built things yet?"
800                 mv .git/hooks .git/hooks-disabled
801         ) || exit
804 test_done () {
805         GIT_EXIT_OK=t
807         if test -z "$HARNESS_ACTIVE"; then
808                 test_results_dir="$TEST_DIRECTORY/test-results"
809                 mkdir -p "$test_results_dir"
810                 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
812                 echo "total $test_count" >> $test_results_path
813                 echo "success $test_success" >> $test_results_path
814                 echo "fixed $test_fixed" >> $test_results_path
815                 echo "broken $test_broken" >> $test_results_path
816                 echo "failed $test_failure" >> $test_results_path
817                 echo "" >> $test_results_path
818         fi
820         if test "$test_fixed" != 0
821         then
822                 say_color pass "# fixed $test_fixed known breakage(s)"
823         fi
824         if test "$test_broken" != 0
825         then
826                 say_color error "# still have $test_broken known breakage(s)"
827                 msg="remaining $(($test_count-$test_broken)) test(s)"
828         else
829                 msg="$test_count test(s)"
830         fi
831         case "$test_failure" in
832         0)
833                 # Maybe print SKIP message
834                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
836                 if test $test_external_has_tap -eq 0; then
837                         say_color pass "# passed all $msg"
838                         say "1..$test_count$skip_all"
839                 fi
841                 test -d "$remove_trash" &&
842                 cd "$(dirname "$remove_trash")" &&
843                 rm -rf "$(basename "$remove_trash")"
845                 exit 0 ;;
847         *)
848                 if test $test_external_has_tap -eq 0; then
849                         say_color error "# failed $test_failure among $msg"
850                         say "1..$test_count"
851                 fi
853                 exit 1 ;;
855         esac
858 # Test the binaries we have just built.  The tests are kept in
859 # t/ subdirectory and are run in 'trash directory' subdirectory.
860 if test -z "$TEST_DIRECTORY"
861 then
862         # We allow tests to override this, in case they want to run tests
863         # outside of t/, e.g. for running tests on the test library
864         # itself.
865         TEST_DIRECTORY=$(pwd)
866 fi
867 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
869 if test -n "$valgrind"
870 then
871         make_symlink () {
872                 test -h "$2" &&
873                 test "$1" = "$(readlink "$2")" || {
874                         # be super paranoid
875                         if mkdir "$2".lock
876                         then
877                                 rm -f "$2" &&
878                                 ln -s "$1" "$2" &&
879                                 rm -r "$2".lock
880                         else
881                                 while test -d "$2".lock
882                                 do
883                                         say "Waiting for lock on $2."
884                                         sleep 1
885                                 done
886                         fi
887                 }
888         }
890         make_valgrind_symlink () {
891                 # handle only executables
892                 test -x "$1" || return
894                 base=$(basename "$1")
895                 symlink_target=$GIT_BUILD_DIR/$base
896                 # do not override scripts
897                 if test -x "$symlink_target" &&
898                     test ! -d "$symlink_target" &&
899                     test "#!" != "$(head -c 2 < "$symlink_target")"
900                 then
901                         symlink_target=../valgrind.sh
902                 fi
903                 case "$base" in
904                 *.sh|*.perl)
905                         symlink_target=../unprocessed-script
906                 esac
907                 # create the link, or replace it if it is out of date
908                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
909         }
911         # override all git executables in TEST_DIRECTORY/..
912         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
913         mkdir -p "$GIT_VALGRIND"/bin
914         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
915         do
916                 make_valgrind_symlink $file
917         done
918         OLDIFS=$IFS
919         IFS=:
920         for path in $PATH
921         do
922                 ls "$path"/git-* 2> /dev/null |
923                 while read file
924                 do
925                         make_valgrind_symlink "$file"
926                 done
927         done
928         IFS=$OLDIFS
929         PATH=$GIT_VALGRIND/bin:$PATH
930         GIT_EXEC_PATH=$GIT_VALGRIND/bin
931         export GIT_VALGRIND
932 elif test -n "$GIT_TEST_INSTALLED" ; then
933         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
934         error "Cannot run git from $GIT_TEST_INSTALLED."
935         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
936         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
937 else # normal case, use ../bin-wrappers only unless $with_dashes:
938         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
939         if ! test -x "$git_bin_dir/git" ; then
940                 if test -z "$with_dashes" ; then
941                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
942                 fi
943                 with_dashes=t
944         fi
945         PATH="$git_bin_dir:$PATH"
946         GIT_EXEC_PATH=$GIT_BUILD_DIR
947         if test -n "$with_dashes" ; then
948                 PATH="$GIT_BUILD_DIR:$PATH"
949         fi
950 fi
951 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
952 unset GIT_CONFIG
953 GIT_CONFIG_NOSYSTEM=1
954 GIT_CONFIG_NOGLOBAL=1
955 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
957 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
959 if test -z "$GIT_TEST_CMP"
960 then
961         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
962         then
963                 GIT_TEST_CMP="$DIFF -c"
964         else
965                 GIT_TEST_CMP="$DIFF -u"
966         fi
967 fi
969 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
970 export GITPERLLIB
971 test -d "$GIT_BUILD_DIR"/templates/blt || {
972         error "You haven't built things yet, have you?"
975 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
976 then
977         GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
978         export GITPYTHONLIB
979         test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
980                 error "You haven't built git_remote_helpers yet, have you?"
981         }
982 fi
984 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
985         echo >&2 'You need to build test-chmtime:'
986         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
987         exit 1
988 fi
990 # Test repository
991 test="trash directory.$(basename "$0" .sh)"
992 test -n "$root" && test="$root/$test"
993 case "$test" in
994 /*) TRASH_DIRECTORY="$test" ;;
995  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
996 esac
997 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
998 rm -fr "$test" || {
999         GIT_EXIT_OK=t
1000         echo >&5 "FATAL: Cannot prepare test area"
1001         exit 1
1004 test_create_repo "$test"
1005 # Use -P to resolve symlinks in our working directory so that the cwd
1006 # in subprocesses like git equals our $PWD (for pathname comparisons).
1007 cd -P "$test" || exit 1
1009 HOME=$(pwd)
1010 export HOME
1012 this_test=${0##*/}
1013 this_test=${this_test%%-*}
1014 for skp in $GIT_SKIP_TESTS
1015 do
1016         case "$this_test" in
1017         $skp)
1018                 say_color skip >&3 "skipping test $this_test altogether"
1019                 skip_all="skip all tests in $this_test"
1020                 test_done
1021         esac
1022 done
1024 # Provide an implementation of the 'yes' utility
1025 yes () {
1026         if test $# = 0
1027         then
1028                 y=y
1029         else
1030                 y="$*"
1031         fi
1033         while echo "$y"
1034         do
1035                 :
1036         done
1039 # Fix some commands on Windows
1040 case $(uname -s) in
1041 *MINGW*)
1042         # Windows has its own (incompatible) sort and find
1043         sort () {
1044                 /usr/bin/sort "$@"
1045         }
1046         find () {
1047                 /usr/bin/find "$@"
1048         }
1049         sum () {
1050                 md5sum "$@"
1051         }
1052         # git sees Windows-style pwd
1053         pwd () {
1054                 builtin pwd -W
1055         }
1056         # no POSIX permissions
1057         # backslashes in pathspec are converted to '/'
1058         # exec does not inherit the PID
1059         test_set_prereq MINGW
1060         test_set_prereq SED_STRIPS_CR
1061         ;;
1062 *CYGWIN*)
1063         test_set_prereq POSIXPERM
1064         test_set_prereq EXECKEEPSPID
1065         test_set_prereq NOT_MINGW
1066         test_set_prereq SED_STRIPS_CR
1067         ;;
1068 *)
1069         test_set_prereq POSIXPERM
1070         test_set_prereq BSLASHPSPEC
1071         test_set_prereq EXECKEEPSPID
1072         test_set_prereq NOT_MINGW
1073         ;;
1074 esac
1076 test -z "$NO_PERL" && test_set_prereq PERL
1077 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1079 # test whether the filesystem supports symbolic links
1080 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1081 rm -f y
1083 # When the tests are run as root, permission tests will report that
1084 # things are writable when they shouldn't be.
1085 test -w / || test_set_prereq SANITY